/*
 * Copyright 1993-1995 Vectaport Inc, Jorge A. Gautier Consulting 
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

#ifndef vpfeditor_h
#define vpfeditor_h

#include <MapUnidraw/mapeditor.h>
#include <VpfUnidraw/vpfkit.h>

class MapFClassComp;
class Selection;
class VpfDatabase;
class VpfFeatureClass;

class VpfEditor : public MapEditor {
public:
    VpfEditor(OverlayComp*, OverlayKit* = VpfKit::Instance());
    VpfEditor(boolean initflag, OverlayKit* = VpfKit::Instance());
    VpfEditor(const char* file, OverlayKit* = VpfKit::Instance());
    void Init(OverlayComp* = nil, const char* name = "VpfEditor");
    virtual void InitCommands();
    virtual void AddCommands(ComTerp*);
    Selection* tiles() { return _tiles; }
    void tiles(Selection* s);
    void FClassState(VpfFeatureClass*, boolean);

    VpfDatabase* GetMapDatabase();
    void SetMapDatabase(VpfDatabase* db);
    void toolbar0();
    void toolbar1();
    void ExplainTileSel(char*);
    virtual void UpdateLayerMenu();
    virtual void UpdateLibraryMenu();
  MapFClassComp* Graticule() { return _graticule; }
  void Graticule(MapFClassComp* c) { _graticule = c; }
protected:
    virtual void InitMapComp();
    Selection* _tiles;
    MapFClassComp* _graticule;
};

#endif
